#!/usr/bin/python3.6
#FHSE in mhz
FHSE = 25

#cpu search frequency range
fmin = 239
fmax = 500

#clk1 = clk / m
m = list(range(1,64))
#vco = clk1 * n
n = list(range(0,512))
#vco / p = system clock - mcu speed (not systick)
p = list(range(0,128,2))
#vco / q = 48mhz - usb
q = list(range(1,128))
for mi in m:
    for ni in n:
        fvco = FHSE * ni / mi
        if fvco > 836:
            continue
        #pll1
        for qi in q:
            fusb = fvco / qi
            if not ( fusb == int(fusb) and fusb == 48 ):
                    continue
            for pi in p:
                if pi == 0:
                    pi = 1
                fcpu = fvco / pi
                if not fcpu == int(fcpu):
                    continue
                if fusb == 48 \
                   and ( fcpu >= fmin and fcpu <= fmax):
                    print('FHSE:', FHSE,
                      'm:', mi,
                      'n:', ni,
                      'p:', pi,
                      '(RCC_PLLP_DIV' + str(pi) + ')',
                      'q:', qi,
                      'fusb:', fusb,
                      'fcpu:', fcpu)

